﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="DropDownProviderPerRow.aspx.cs" Inherits="WebDataGrid.DropDownProviderPerRow" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title></title>
    <script type="text/javascript" id="igClientScript">
<!--

        var COLOR_ID_INDEX = 0;
        var _lastColorId = -1;

        // get a ref to the WebDataGrid
        function getGrid() {
            return $find('WebDataGrid1');
        }

        // get a ref to the row that is currently in edit mode
        function getActiveGridRow() {
            return getGrid().get_behaviors().get_activation().get_activeCell().get_row();
        }

        // get the ColorId of the currently active row
        function getActiveColorId() {
            var row = getActiveGridRow();
            var result = 0;
            if (row != null) {
                result = row.get_cell(COLOR_ID_INDEX).get_value();
                return result;
            }
        }

        // ----------------------------------------------------------------

        function ShadeDDP_DropDownOpening(sender, eventArgs)
        {
	        ///<summary>
	        ///
	        ///</summary>
	        ///<param name="sender" type="Infragistics.Web.UI.WebDropDown"></param>
	        ///<param name="eventArgs" type="Infragistics.Web.UI.DropDownContainerEventArgs"></param>

            var colorId = getActiveColorId();
            if (colorId != _lastColorId) {
                Log('ShadeDDP_DropDownOpening, loadItems, ColorId = ' + colorId);
                _lastColorId = colorId; // don't reload the items if they are currently loaded in the dropdown
                sender.loadItems(colorId.toString(), false);
            } else {
                Log('ShadeDDP_DropDownOpening, items already loaded.');
            }

        }// -->


        // ----------------------------------------------------------------
        function Log(message) {
            document.getElementById('log').value += message + "\n";
        }

        function clearLog() {
            document.getElementById('log').value = '';
        }           


</script>
</head>
<body>
    <form id="form1" runat="server">
    <div>

    <ig:WebScriptManager ID="WebScriptManager1" runat="server" />
    <div style="border: 2px solid black; padding: 10px; font-family: Arial; background-color: #ddddff">
    JavaScript Log (<a href="" onclick="javascript:clearLog(); return false;">clear</a>)<br />
    <textarea id="log" cols="160" rows="10" style="background-color: #ffff99; width: 100%"></textarea>
    </div>

    <br />
    This example shows how to have different DropDownProvider DataSource for each row of a WebDataGrid.<br />
    <br />
    It works by handling the client-side DropDownOpening event, which calls loadItems, which triggers the server-side ItemsRequested event.<br />
    During the ItemsRequested event handler, the DropDownProvider's EditorControl (which is a WebDataGrid) is bound with new data.<br />
    <br />
    This example works well, however each time DropDownOpening fires, a round trip to the server is made to get the list item data.<br />
    I am looking for a way to cache the DropDownItemCollection on the client.<br />
    <br />
    Also, I can't seem to get the AjaxIndicator to appear while loadItems() is being called.<br />
    <br />
    <ig:WebDataGrid ID="WebDataGrid1" runat="server" Height="350px" Width="400px" 
            AutoGenerateColumns="False" ClientIDMode="Static">
        <Columns>
            <ig:BoundDataField DataFieldName="ColorId" Hidden="True" Key="ColorId">
                <Header Text="ColorId" />
            </ig:BoundDataField>
            <ig:BoundDataField DataFieldName="ColorName" Key="ColorName">
                <Header Text="Colors" />
            </ig:BoundDataField>
            <ig:BoundDataField DataFieldName="ShadeName" Key="ShadeName">
                <Header Text="Shade" />
            </ig:BoundDataField>
        </Columns>
        <EditorProviders>
            <ig:DropDownProvider ID="ShadeDDP">           
                <EditorControl ClientIDMode="Predictable" DropDownContainerMaxHeight="200px" 
                    EnableAnimations="False" EnableDropDownAsChild="False" OnItemsRequested="ShadeDDP_ItemsRequested" 
                    TextField="ShadeName" ValueField="ShadeId">
                    <ClientEvents DropDownOpening="ShadeDDP_DropDownOpening" />
                    <DropDownItemBinding TextField="ShadeName" ValueField="ShadeName" />
                    <AjaxIndicator Enabled="True" Text="Loading" Location="TopCenter" />
                </EditorControl>
            </ig:DropDownProvider>
        </EditorProviders>
        <Behaviors>
            <ig:EditingCore AutoCRUD="False">
                <Behaviors>
                    <ig:CellEditing>
                        <ColumnSettings>
                            <ig:EditingColumnSetting ColumnKey="ShadeName" EditorID="ShadeDDP" />
                            <ig:EditingColumnSetting ColumnKey="ColorName" ReadOnly="True" />
                        </ColumnSettings>
                        <EditModeActions MouseClick="Single" />
                    </ig:CellEditing>
                </Behaviors>
            </ig:EditingCore>
            <ig:Activation>
            </ig:Activation>
            <ig:Selection>
            </ig:Selection>
        </Behaviors>
    </ig:WebDataGrid>

    </div>
    </form>
</body>
</html>

