﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Data;
using System.Text;
using System.Collections;

namespace WebDataGrid
{
    public static class SampleData
    {

        public static DataTable GetShadeColorDataTable()
        {
            DataTable dt = new DataTable("ShadeColor");

            dt.Columns.Add("ShadeId", typeof(int));
            dt.Columns.Add("ShadeName", typeof(string));
            dt.Columns.Add("ColorId", typeof(int));
            dt.Columns.Add("ColorName", typeof(string));

            dt.Rows.Add(2, "ruby", 0, "red");
            dt.Rows.Add(5, "peach", 1, "orange");
            dt.Rows.Add(8, "jasmine", 2, "yellow");
            dt.Rows.Add(11, "jade", 3, "green");
            dt.Rows.Add(14, "ultramarine", 4, "blue");
            dt.Rows.Add(15, "electric", 5, "indigo");
            dt.Rows.Add(20, "lavender", 6, "violet");

            return dt;
        }

        public static DataTable GetShadeDataTable()
        {
            DataTable dt = new DataTable("Shade");

            dt.Columns.Add("ShadeId", typeof(int));
            dt.Columns.Add("ColorId", typeof(int));
            dt.Columns.Add("ShadeName", typeof(string));            
            
            dt.Rows.Add(0, 0, "pink");
            dt.Rows.Add(1, 0, "raspberry");
            dt.Rows.Add(2, 0, "ruby");
            dt.Rows.Add(3, 1, "tangerine");
            dt.Rows.Add(4, 1, "salmon");
            dt.Rows.Add(5, 1, "peach");
            dt.Rows.Add(6, 2, "saffron");
            dt.Rows.Add(7, 2, "pear");
            dt.Rows.Add(8, 2, "jasmine");
            dt.Rows.Add(9, 3, "lime");
            dt.Rows.Add(10, 3, "olive");
            dt.Rows.Add(11, 3, "jade");
            dt.Rows.Add(12, 4, "cyan");
            dt.Rows.Add(13, 4, "turquoise");
            dt.Rows.Add(14, 4, "ultramarine");
            dt.Rows.Add(15, 5, "electric");
            dt.Rows.Add(16, 5, "blue-violet");
            dt.Rows.Add(17, 5, "pigment indigo");
            dt.Rows.Add(18, 6, "eggplant");
            dt.Rows.Add(19, 6, "sangria");
            dt.Rows.Add(20, 6, "lavender");

            return dt;
        }

        /// <summary>
        /// Get a table representing a list of colors.
        /// </summary>
        /// <returns></returns>
        public static DataTable GetColorDataTable()
        {

            DataTable dt = new DataTable("Color");

            dt.Columns.Add("ColorId", typeof(int));
            dt.Columns.Add("ColorName", typeof(string));

            dt.Rows.Add(0, "red");
            dt.Rows.Add(1, "orange");
            dt.Rows.Add(2, "yellow");
            dt.Rows.Add(3, "green");
            dt.Rows.Add(4, "blue");
            dt.Rows.Add(5, "indigo");
            dt.Rows.Add(6, "violet");

            return dt;

        }

        /// <summary>
        /// Get a table representing a list of people and their favorite colors
        /// The DataTable returned by this method represents the data returned by a join of the Person table 
        /// and the Color table. In the database, the Person table does not actually have the column FavoriteColorText.        
        /// </summary>
        /// <returns></returns>
        public static DataTable GetPersonDataTable()
        {
            DataTable dt = new DataTable();
            dt.Columns.Add("PersonId", typeof(int));
            dt.Columns.Add("PersonName", typeof(string));
            dt.Columns.Add("ColorId", typeof(int));
            dt.Columns.Add("ColorName", typeof(string));

            dt.Rows.Add(0, "Randy", 0, "red");
            dt.Rows.Add(1, "Omar", 1, "orange");
            dt.Rows.Add(2, "Yuri", 2, "yellow");
            dt.Rows.Add(3, "Gabriel", 3, "green");
            dt.Rows.Add(4, "Bob", 4, "blue");
            dt.Rows.Add(5, "Ishmael", 5, "indigo");
            dt.Rows.Add(6, "Vinny", 6, "violet");
            return dt;
        }

        /// <summary>
        /// Create a string representation of a hash table's keys and values.
        /// This may throw an exception if the keys or values are not strings.
        /// </summary>
        /// <param name="ht"></param>
        /// <returns></returns>
        public static  string HashTableToString(Hashtable ht)
        {
            string result = "";
            StringBuilder sb = new StringBuilder();

            string[] keys = new string[ht.Keys.Count];
            ht.Keys.CopyTo(keys, 0);
            Array.Sort(keys);

            foreach (string key in keys)
            {
                sb.AppendFormat("['{0}'] = '{1}', ", key, ht[key]);
            }
            result = sb.ToString().Substring(0, sb.Length - 2);
            return result;
        }

        public static DataTable PersonTable(string key)
        {
            DataTable value = (DataTable)HttpContext.Current.Session[key];
            if (value == null)
            {
                value = SampleData.GetPersonDataTable();
                HttpContext.Current.Session[key] = value;
            }
            return value;
        }
    }

}